package body Listas_Apunt_Lineas is

     procedure Crear_Lista_Vacia (LAL : out Tipo_Lista_Apunt_Lineas) is
       begin
         Crear_Vacia (LAL);
       end Crear_Lista_Vacia;  
     
     
     procedure Annadir_Linea (LAL : in out Tipo_Lista_Apunt_Lineas;
                              Lin : in Lineas.Linea) is
          Aplin : Apunt_Linea;
       begin
         ApLin := new Lineas.Linea;
         Lineas.Copiar (ApLin.all, Lin);
         Annadir (LAL, ApLin);
       end Annadir_Linea;
       
       
     procedure Copiar_Puntero (L1: out Tipo_Lista_Apunt_Lineas;
                               L2: in Tipo_Lista_Apunt_Lineas) is
       begin
         Copiar (L1, L2);
       end Copiar_Puntero;


     function Resto_Lista (LAL : Tipo_Lista_Apunt_Lineas)
          return Tipo_Lista_Apunt_Lineas is
       begin
         return Resto (LAL);
       end Resto_Lista;
     
          
     function Dame_Linea_n (LAL: Tipo_Lista_Apunt_Lineas; N: Positive)
          return Apunt_Linea is
       begin
         return Valor (LAL, N);
       exception
         when Lista_Lineas.Posicion_Excesiva =>
              return null;
       end Dame_Linea_n;


       
     function Dame_Linea (LAL : Tipo_Lista_Apunt_Lineas)
          return Apunt_Linea is
       begin
         return Primero (LAL);
       end Dame_Linea;     
       
       
     function Es_Lista_Vacia (LAL: Tipo_Lista_Apunt_Lineas) return Boolean is
       begin
         return Es_Vacia (LAL);
       end Es_Lista_Vacia;



     procedure Copiar_Lista (LAL1: out Tipo_Lista_Apunt_Lineas;
                             LAL2: in Tipo_Lista_Apunt_Lineas) is
          Aux : Tipo_Lista_Apunt_Lineas := LAL2;
          Lin : Lineas.Linea;
       begin
         Crear_Vacia (LAL1);
         while not Es_Vacia(Aux) loop
           Lineas.Copiar_Lista (Lin, Dame_Linea (Aux).all);
           Annadir_Linea (LAL1, Lin);
           Aux := Resto (Aux);
         end loop;  
       end Copiar_Lista;


end Listas_Apunt_Lineas;