with Text_io;

package body lista_palabras_reservadas is


     Nombre_Fichero: constant String := "fpals_reservadas.txt";
     Lista_Palabras : Palabras_Reservadas.ListOrd;


     procedure Inicializar is


        FPalRes : Text_io.File_Type;


       function LeerLinea return Strings_Variables.String_Variable is
            StrLin : StrClave := (others => ' ');
            StrVar : Strings_Variables.String_Variable;
            Lon    : Natural;
         begin
           Strings_Variables.Copiar(strVar, Strings_Variables.FString_Vacio);
           Text_io.Get_Line (StrLin, Lon);
           Strings_Variables.Copiar (StrVar, Strings_Variables.En_Minusculas(
                Strings_Variables.FString_Var (StrLin(1..Lon))));
           return StrVar;
         end LeerLinea;



       begin
         Palabras_Reservadas.Crear_Vacia (Lista_Palabras);
         Text_io.Open (FPalRes, Text_io.In_File, Nombre_Fichero);
         Text_io.Set_Input (FPalRes);
         while not Text_io.End_of_file (FPalRes) loop
            Palabras_Reservadas.Insertar (Lista_Palabras, LeerLinea);
         end loop;
         Text_io.Close (FPalRes);
         Text_io.Set_Input (Text_io.Standard_Input);
       exception
         when Text_io.Name_Error =>
           raise Fichero_No_Encontrado;
       end Inicializar;


    function Esta (H: in Strings_Variables.String_Variable) return Boolean is
      begin

        return Palabras_Reservadas.Esta (Lista_Palabras,
             Strings_Variables.En_Minusculas(H));
      end Esta;


     function DameClave (E: Strings_Variables.String_Variable)
          return StrClave is
         S : StrClave := (others => ' ');

       begin
         S(1..Strings_Variables.Longitud(E)) := Strings_Variables.Valor(E);
         return S;
       end DameClave;


end lista_palabras_reservadas;

