   with text_io,
        lista_palabras_reservadas;

package body Programa_Original is

     Lista_Programa : Listas_Apunt_Lineas.Tipo_Lista_Apunt_Lineas;
     Num_Lin : Natural := 0;



     procedure Inicializar (NombreFichero: String) is

          subtype S100 is String(1..Strings_Variables.Max);


          FEnt   : Text_io.File_Type;
          StrVar : Strings_Variables.String_Variable;
          Lin    : Lineas.Linea;


       function LeerLinea return Strings_Variables.String_Variable is
            StrLin : S100 := (others => ' ');
            StrVar : Strings_Variables.String_Variable;
            Lon    : Natural;
         begin
           Strings_Variables.Copiar(strVar, Strings_Variables.FString_Vacio);
           Text_io.Get_Line (StrLin, Lon);
           Strings_Variables.Copiar (StrVar, Strings_Variables.FString_Var(
                StrLin(1..Lon)));
           return StrVar;
         end LeerLinea;


       begin
         Text_io.Open (FEnt, Text_io.In_File, NombreFichero);
         Lista_Palabras_Reservadas.Inicializar;
         Text_io.Set_Input (FEnt);
         while not Text_io.End_of_File (FEnt) loop
            Num_Lin := Num_Lin + 1;
            Strings_Variables.Copiar (StrVar, LeerLinea);
            Lineas.Copiar (Lin, Lineas.Crear (Num_Lin, StrVar));
            Listas_Apunt_Lineas.Annadir_Linea (Lista_Programa, Lin);
         end loop;
         Text_io.Close (FEnt);
         Text_io.Set_Input (Text_io.Standard_Input);
       exception
         when Text_io.Name_Error =>
              raise Fichero_No_Encontrado;
       end Inicializar;



     function Dame_Linea_n (N: Positive)
          return Listas_Apunt_Lineas.Apunt_Linea is

       begin
         return Listas_Apunt_Lineas.Dame_Linea_n (Lista_Programa, N);
       end Dame_Linea_n;



     function Dame_NumLin return Natural is
       begin
         return Num_Lin;
       end Dame_NumLin;


     function Dame_Lista return Listas_Apunt_Lineas.Tipo_Lista_Apunt_Lineas is
       begin
         return Lista_Programa;
       end Dame_Lista;



     function Dame_Contexto (N: Positive; Nivel : Positive)
        return Contextos.Contexto is

          Ctx: Contextos.Contexto;
       begin

         Contextos.Crear_Contexto (Ctx, Lista_Programa, N, Nivel);
         return Ctx;
       end Dame_Contexto;


end programa_original;
