with listas_apunt_lineas,
     strings_variables,
     tokens;

package programa_traducido is

procedure Inicializar;
-- Entrada:
-- Salida :
-- Efecto : Inicializa la lista de apuntadores de lineas
--          'programa_traducido' que contendra la version traducida del
--          programa haciendo una copia fisica de la lista que contiene
--          el programa original del paquete 'programa_original'

procedure Traducir (NLin: in Positive;
                    Tok : in Tokens.Token;
                    Trad: in Strings_Variables.String_Variable);
-- Entrada: Positivo <- NLin   ( numero Linea )
--          Token <- Tok
--          String_Variable <- Trad   ( traduccion )
-- Salida :
-- Efecto : produce la traduccion del Token 'Tok' en la linea 'NLin' por
--          el string_variable 'Trad' en la lista 'programa_traducido'

procedure Escribir_Traducido (Nombre : in String);
-- Entrada: String <- Nombre
-- Salida :
-- Efecto : crea un fichero de texto de nombre 'Nombre' a partir de la
--          lista 'programa_traducido'


end programa_traducido;
