with text_io,
     tokens,
     strings_variables;

package body Contextos is



function Crear_Vacio return Contexto is
       Ctx : Contexto;
  begin
    Crear_Lista_Vacia (Ctx);
    return Ctx;
  end Crear_Vacio;


procedure Crear_Contexto
      (Ctx: out Contexto;
       LAL: in Listas_Apunt_Lineas.Tipo_Lista_Apunt_Lineas;
       NumLin: in Positive;
       Nivel: in Positive) is

      Aux : Listas_Apunt_Lineas.Apunt_Linea;
      Prim, Ult, Act : Positive;

  begin
    if NumLin <= Nivel then
         Prim := 1;
    else
         Prim := NumLin - Nivel;
    end if;
    Ult := NumLin + Nivel;
    Act := Prim;
    Ctx := Crear_Vacio;
    loop
      Aux := Listas_Apunt_Lineas.Dame_Linea_n (LAL, Act);
      exit when Aux = null or Act > Ult;
      Annadir_Linea (Ctx, Aux.all);
      Act := Act + 1;
    end loop;
  end Crear_Contexto;


procedure Escribir_Contexto (
               Ctx : Contexto;
            ActTok : Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens) is

           PCtx : Contexto;
           PTok : Listas_Apunt_Tokens.Tipo_Lista_Apunt_Tokens;
           Tok  : Tokens.Token;

           package Int_io is new Text_io.Integer_io(Positive);

  begin
    Copiar_Puntero (PCtx, Ctx);
    for i in 1..78 loop text_io.put ('-'); end loop;
    text_io.new_line;
      while not Es_Lista_Vacia(PCtx) loop
        Listas_Apunt_Tokens.Copiar_Puntero (PTok, Lineas.Analisis (
             Dame_Linea (PCtx).all));
        -- Escribe el num. de linea de la linea actual
        Int_io.Put (
             Item => Lineas.Numero_Linea (Dame_Linea (PCtx).all),
             Width => 3);
        Text_io.Put (": ");
        while not Listas_Apunt_Tokens.Es_Lista_Vacia(PTok) loop
           Tokens.Copiar (Tok, Listas_Apunt_Tokens.Primer_Token(PTok).all);
           -- para realizar resaltado en pantalla del token que se esta
           -- traduciendo en ese momento (se utilizan codigos ANSI
           if Listas_Apunt_Tokens."=" (PTok, ActTok) then
                Text_io.Put (ASCII.ESC & "[7m");
                Text_io.Put (Strings_Variables.Valor(Tokens.Cadena(Tok)));
                Text_io.Put (ASCII.ESC & "[0m");
           else
                Text_io.Put (Strings_Variables.Valor(Tokens.Cadena(Tok)));
           end if;
           Listas_Apunt_Tokens.Copiar_Puntero (PTok,
                Listas_Apunt_Tokens.Resto_Lista (PTok));
         end loop;
         Text_Io.New_Line;
         Copiar_Puntero (PCtx, Resto_Lista (PCtx));
       end loop;
     for i in 1..78 loop text_io.Put ('-'); end loop; text_io.new_Line;
   end Escribir_Contexto;


end Contextos;

