
package body Gestion_Menus is
	
    Ultima_Opcion : TOpcion := '0';
    Opcion_Incorrecta : exception;
    
    procedure Inicializar 
        (Nombre_FOpciones : in String; FOpciones : in out TMenu) is
    begin
        Text_IO.Open (FOpciones, Text_IO.In_File, Nombre_FOpciones); 
    end Inicializar;

    procedure Visualizar (FOpciones : in out TMenu) is
        L : String (1 .. 50);
        Z : TOpcion := '0';
        Ult_Car : Natural;
    begin
        Text_IO.New_Page;
        Text_IO.Set_Line (10);
        Text_IO.Set_Col (25);
        Text_IO.Put_Line ("MENU");
        Text_IO.Set_Line (15);
        Text_IO.Set_Col (15);
        Text_IO.Put_Line ("0: Salir");
        Text_IO.New_Line (2);
        while not Text_IO.End_of_File (FOpciones) loop
            Z := Character'Succ (Z);
            Text_IO.Get_Line (FOpciones, L, Ult_Car);
            Text_IO.Set_Col (15);
            Text_IO.Put (Z);
            Text_IO.Put_Line (": " & L(1 .. Ult_Car));
            Text_IO.New_Line (2);
        end loop;
        Ultima_Opcion := Z;
        Text_IO.Close (FOpciones);
    end Visualizar;

    function Opcion return TOpcion is
        O : TOpcion;
    begin
        Text_IO.Put_Line ("Elige una opcion (0 para salir): ");
        Text_IO.Get (O);
        if O > Ultima_Opcion then
	   raise Opcion_Incorrecta;
	else
	   Text_IO.Skip_Line;
	   return O;
        end if;
    exception
        when Constraint_Error | Opcion_Incorrecta =>
	   Text_IO.Skip_Line;
	   Text_IO.Put_Line ("Opcion incorrecta");            
	   return Opcion;
    end Opcion;
   
end Gestion_Menus;
