package body Listas_Apunt_Tokens is


  procedure Crear_Lista_Vacia (LAT: in out Tipo_Lista_Apunt_Tokens) is
    begin
      Crear_Vacia (LAT);
    end Crear_Lista_Vacia;  

     
  procedure Annadir_Token (LAT: in out Tipo_Lista_Apunt_Tokens;
                              T : Apunt_Token) is
    begin
      Annadir (LAT, T);
    end Annadir_Token;                                


  procedure Copiar_Puntero (LAT1: out Tipo_Lista_Apunt_Tokens;
                            LAT2: in Tipo_Lista_Apunt_Tokens) is
    begin
      Copiar (LAT1, LAT2);
    end Copiar_Puntero;                          


    
  procedure Copiar_Lista (LAT1: out Tipo_Lista_Apunt_Tokens;
                           LAT2: in Tipo_Lista_Apunt_Tokens) is
      Aux : Tipo_Lista_Apunt_Tokens;
      PTok : Apunt_Token;
    begin
      Crear_Vacia(LAT1);
      Aux := LAT2;
      while not Es_Vacia(Aux) loop
        Ptok := new Tokens.Token;
        Tokens.Copiar (PTok.all, Primero (Aux).all);
        Annadir (LAT1, PTok);
        Aux := Resto(Aux);
      end loop;
    end Copiar_Lista;    



  function Primer_Token (LAT: Tipo_Lista_Apunt_Tokens) return Apunt_Token is
    begin
      return Primero (LAT);
    end Primer_Token;
      

  function Resto_Lista (LAT: Tipo_Lista_Apunt_Tokens)
          return Tipo_Lista_Apunt_Tokens is
    begin
      return Resto (LAT);
    end Resto_Lista;  

          
  function Es_Lista_Vacia (LAT: Tipo_Lista_Apunt_Tokens) return Boolean is
    begin
      return Es_Vacia (LAT);
    end Es_Lista_Vacia;  


  procedure Hacer_String (LAT:in Tipo_Lista_Apunt_Tokens;
                          Str:in out Strings_Variables.String_Variable) is
       Cat : Strings_Variables.String_Variable;
    begin
      if not Es_Vacia (LAT) then
          Strings_Variables.Copiar (Cat, Strings_Variables.FString_Vacio);
          Strings_Variables.Copiar (Cat, Tokens.Cadena (Primero (LAT).all));
                  
          Strings_Variables.Copiar (Str, Strings_Variables."&"(Str,Cat));
             
          Hacer_String (Tipo_Lista_Apunt_Tokens (Resto (LAT)), Str);
      end if;
    end Hacer_String;      


      
end Listas_Apunt_Tokens;

