PM_TEST3.ADB


with Text_IO;

package body Menuen_Kudeaketa is
   
   Azken_Aukera : TAukera := '0';
   Aukera_Desegokia : exception;
   
   procedure Hasieratu 
     (FAukerak_Izena : in String; FAukerak : in out Menu) is
   begin
      Text_IO.Open (FAukerak, Text_IO.In_File, FAukerak_Izena); 
   end Hasieratu;
   
   procedure Erakutsi (FAukerak : in out Menu) is
      L : String (1 .. 60);
      Z : TAukera := '0';
      Azken_Kar : Natural;
   begin
      Text_IO.New_Page;
      Text_IO.Set_Line (10);         -- menua hamargarren zutabean
      Text_IO.Set_Col (25);          -- kokatzeko eta erdiratzeko
      Text_IO.Put_Line ("MENUA");    -- aginduak
      Text_IO.Set_Line (15);
      Text_IO.Set_Col (10);
      Text_IO.Put_Line ("0: Irten");
      Text_IO.New_Line (2);
      while not Text_IO.End_of_File (FAukerak) loop
	 Z := Character'Succ (Z);
	 Text_IO.Get_Line (FAukerak, L, Azken_Kar);
	 Text_IO.Set_Col (10);
	 Text_IO.Put (Z);
	 Text_IO.Put_Line (": " & L(1 .. Azken_Kar));
	 Text_IO.New_Line (2);
      end loop;
      Azken_Aukera := Z;
      Text_IO.Close (FAukerak);
   end Erakutsi;
   
   function Aukera return TAukera is
      O : TAukera;
   begin
      Text_IO.Put_Line ("Hautatu aukera bat (irteteko 0)" &
			" eta gogoratu 0 dela :");
      Text_IO.Get (O);
      if O > Azken_Aukera then
	 raise Aukera_Desegokia;
      else
	 Text_IO.Skip_Line;
	 return O;
      end if;
   exception
      when Constraint_Error | Aukera_Desegokia =>
	 Text_IO.Skip_Line;
	 Text_IO.Put_Line ("Aukera desegokia");            
	 return Aukera;
   end Aukera;
   
end Menuen_Kudeaketa;
