with text_io,
     programa_original,
     lineas;


package body programa_traducido is

     Lista_Traducido : Listas_Apunt_Lineas.Tipo_Lista_Apunt_Lineas;


procedure Inicializar is
  begin
    Listas_Apunt_Lineas.Crear_Lista_Vacia (Lista_Traducido);
    Listas_Apunt_Lineas.Copiar_Lista (Lista_Traducido,
         Programa_Original.Dame_Lista);
  end Inicializar;


function Dame_Linea_n (N: Positive) return Listas_Apunt_Lineas.Apunt_Linea is

  begin
    return Listas_Apunt_Lineas.Dame_Linea_n (Lista_Traducido, N);
  end Dame_Linea_n;



procedure Traducir (NLin: in Positive;
                    Tok : in Tokens.Token;
                    Trad: in Strings_Variables.String_Variable) is

  begin
     Lineas.Traducir (Dame_Linea_n(NLin).all, Tok, Trad);
  end Traducir;



procedure Escribir_Traducido (Nombre : in String) is

     Aux : Listas_Apunt_Lineas.Tipo_Lista_Apunt_Lineas;
     StrVar : Strings_Variables.String_Variable;
     FSal : Text_io.File_Type;
  begin
    Text_io.Create (FSal, Text_io.Out_File, Nombre);
    Listas_Apunt_Lineas.Copiar_Puntero (Aux, Lista_Traducido);
    while not Listas_Apunt_Lineas.Es_Lista_Vacia (Aux) loop
        Strings_Variables.Copiar (StrVar,
        Lineas.Cadena (Listas_Apunt_Lineas.Dame_Linea (Aux).all));
        Text_io.Put_Line(FSal, Strings_Variables.Valor (StrVar));
        Listas_Apunt_Lineas.Copiar_Puntero (Aux,
             Listas_Apunt_Lineas.Resto_Lista (Aux));
    end loop;
    Text_io.Close (FSal);
  end Escribir_Traducido;


end Programa_Traducido;
